#if !defined(CSETTINGDLG_HEADER)
#define CSETTINGDLG_HEADER

#include "SettingInfo.hpp"
#include "SettingInfoFactory.hpp"

#include "WindowUtility.hpp"

#include "tstring.hpp"

/*!
 * Ďp[^̐ݒp_CAO
 */
class TaskSettingDialog : protected CSettingInfoFactory::ErrorInfoListener, protected WindowUtility
{
private:
	TaskSettingDialog( const TaskSettingDialog& ); //<! Ȃ
	operator=( const TaskSettingDialog& ); //<! Ȃ

public:
	/*!
	 * ƂȂ鐳Ďp[^w肵č\z܂B
	 * \param v_settingInfo Ďp[^
	 */
	TaskSettingDialog( const CSettingInfo& v_settingInfo );

	/*!
	 * fXgN^
	 */
	virtual ~TaskSettingDialog();

	/*!
	 * _CAO\܂B
	 * \return ͂ꂽꍇtrue
	 */
	bool show(HWND hWnd );

	/*!
	 * p[^\z܂B
	 * ̃\bhshow\bhIĂȂꍇ͌ĂяoĂ͂Ȃ܂B
	 * \param p[^
	 */
	CSettingInfo createSettingInfo() const;

protected:

	/*!
	 * t@Ngp[^̐ݒɉ߂邽тɃG[ʒm܂B
	 * ߂lƂfalsew肷ƃp[^͐ݒ肳܂B
	 * truew肷ƁA񕜂łꍇ͉񕜂ăp[^ݒ肳܂B
	 * Ap[^̉񕜂łȂꍇfalseƓłB
	 * \param v_errorInfo G[
	 * \return 񕜂ꍇtruew肵܂B
	 */
	virtual bool notifyErrorInfo( const tstring& v_errorInfo ) throw();

private:

	/*!
	 * ƂȂp[^_CAÕRg[ɔzu܂B
	 */
	void setInitialParam();

	/*!
	 * _CAOꂽƂɌĂяonhB
	 */
	void OnInitDialog();

	/*!
	 * R}hnh
	 */
	BOOL onCommand( UINT btn );

	/*!
	 * OK{^̃nhB
	 * _CAO͍̓ڂłꍇ̂݃_CAOI܂B
	 */
	void onOK();

	/*!
	 * CANCEL{^̃nhB
	 * _CAO̓͂LZI܂B
	 */
	void onCancel();

	/*!
	 * ĎtH_Inh
	 */
	void onBrowseDir();

	/*!
	 * AvP[VInh
	 */
	void onOpen();

	/*!
	 * ĎԂ̕ۑInh
	 */
	void onSavePersistent();

	/*!
	 * Oo͐Inh
	 */
	void onLogSelect();

private:

	/*!
	 * t@Ng̃G[ʒmH
	 * \param G[Ăꍇtrue
	 */
	inline bool isErrorOccured() const
	{
		return errorOccured_;
	}

	/*!
	 * G[NA܂B
	 */
	void clearError()
	{
		errorOccured_ = false;
	}

	/*!
	 * p[^
	 */
	CSettingInfo settingInfo_;

	/*!
	 * t@Ng
	 */
	CSettingInfoFactory factory_;

	/*!
	 * t@NgG[ʒmꂽtO
	 */
	bool errorOccured_;

	/*!
	 * ̃_CAÕEBhEnhB
	 * ̓_CAOvV[WɂďCxg̑Oɐݒ肳܂B
	 */
	HWND hDlg_;

	/* ȉOnInitDialogŐݒ肳qRg[ */

	HWND hDir;
	HWND hName;
	HWND hVerb;
	HWND hApp;
	HWND hParam;
	HWND hShowWindow;
	HWND hWaitWrite;
	HWND hTolerance;
	HWND hDeletePending;
	HWND hLog;
	HWND hMaxProcess;

	HWND hMaxDepth;
	HWND hDirNotificationAPIRetrySpan;
	HWND hDirNotificationAPIExpirySpan;
	HWND hForceInterval;

	HWND hDelaySignalSpan;
	HWND hAppCurrentDir;

	HWND hPersistentFile;
	HWND hPersistenceDelaySpan;

	/*!
	 * _CAOvV[W
	 */
	static INT_PTR CALLBACK DlgProc(HWND,UINT,WPARAM,LPARAM);
};

#endif
